
%%
close all
clearvars
Pn = 1/16;
Pp = 1/4;
known = 0;
upper=17;
lower=16;
a = lower:upper;
b = lower:upper;

[A,B] = meshgrid(a,b);
c=cat(2,A',B');
d=reshape(c,[],2);
d(d(:,1)<d(:,2))=0;
I = find(d(:,1)~=0);

data = d(I,:);

%data=6*ones(10,2)
dataL = length(data);
simLength =10;%250;
Results2 = zeros(length(data),1);
Results2Bf = zeros(length(data),1);
finscounter=0;

%%

chi2limit = 10.6664; %(MC=500000000, mmax=10)
chi2limit =  11.3785 %(MC=50000000, mmax=12)
chi2limit =  14.5848 %(MC=500000000, mmax=12)
counter=0;
chi2fel2=[];
chi2fel3=[];
for i=2:dataL
    error =0;
    errorBf=0;
    
    for MC = 1:simLength
        counter=counter+1;
        tic
        finscounter=finscounter+1;
        p1 =data(i,1);
        p2 =data(i,2);
        seq = setPeriodicityBinary(zeros(1,1000),[p1 p2]);
        seqN=noiseAdderBinary(seq, Pp, Pn);
        PnPrior=0.5;
        MinPerc=0;
        silent=1;
        %[perBf LrR] = bruteForceIterSol(seqN,upper,Pp,Pn,known,PnPrior,MinPerc,chi2limit,silent);
        tic
        [perBf,~,~,chi2grejen]=bruteForceIterSolMultiVar2(seqN, upper, chi2limit,silent);
        toc
        lambda=5.5;
        
        tic
        [per, lrR, SizeOut]= LogRegSolReweightCCD(seqN, upper, lambda,silent,p1,p2);
        toc
        per = per.*(SizeOut(1:length(per))>0.001)';
        %[per, lrR, SizeOut]= LogRegSol(seqN, 10, lambda,silent);
        %PerM(:,counter) = per;
        if (perBf(1) ~= p1 && perBf(1) ~= p2 )||( perBf(2) ~= p1 && perBf(2) ~= p2) ||  perBf(3)~=0
            errorBf = errorBf +1;
            if  perBf(3)~=0
                chi2fel3=[chi2fel3 chi2grejen];
            end
              if  perBf(2)==0
                chi2fel2=[chi2fel2 chi2grejen];
            end
            
            %disp('fel i BF ocks?') u
        end
        
        if (per(1) ~= p1 && per(1) ~= p2 )||( per(2) ~= p1 && per(2) ~= p2) || per(3)~=0
            error = error +1;
        end
        
        
        
        
        
        Results2Bf(i) = errorBf/simLength;
        Results2(i) = error/simLength; %Obs P-2!!!!
        disp([num2str(finscounter/(simLength*dataL)*100) ,' % is done'])
        tout(counter)=toc;
        disp(['The last step took ' num2str(tout(end))])
        disp(['estimated time left: ' num2str((mean(tout)*simLength*dataL*(1-finscounter/(simLength*dataL)))/(60)) ' Minutes'])
    end
end


%%
R=-0.0*ones(upper-lower+1,upper-lower+1);
RBf=R;

R(I)=Results2;
RBf(I)=Results2Bf;

%save('HigherPn_results_Two_P_MC100_140313','Results2', 'data', 'R')
%save('LASSOx_results_Two_P_MC100_140313','Results2', 'data', 'R', 'Results2Bf', 'RBf')
close all
figure
%R=R-eye(size(R)).*R;

surf(lower:upper,lower:upper,R')
xlabel('Periodicity I_1')
ylabel('Periodicity I_2')
zlabel('Error rate')
title('PECS$_L$','interpreter','latex')
figure
surf(lower:upper,lower:upper,RBf')
xlabel('Periodicity I_1')
ylabel('Periodicity I_2')
zlabel('Error rate')
title('PECS$_G$')
figure
avgerrorLasso=sum(R)./(upper-lower+1:-1:1)
avgerrorBf=sum(RBf)./(upper-lower+1:-1:1)
plot(lower:upper,avgerrorLasso,'.-r')
hold on;
plot(lower:upper,avgerrorBf,':')
hleg=legend('PECS$_L$','PECS$_G$')
set(hleg,'Interpreter','latex')
axis([3 17 0 0.1])
figure
avgerrorLasso=sum(R')./(1:1:upper-lower+1)
avgerrorBf=sum(RBf')./(1:1:upper-lower+1)
plot(lower:upper,avgerrorLasso,'r')
hold on;
plot(lower:upper,avgerrorBf)
hleg=legend('PECS$_L$','PECS$_G$' )
set(hleg,'Interpreter','latex')
%set(gca, 'XTick',lower:upper, 'XTickLabel',{'(3,3)' '(4,3-4)' '(5,3-5)' '(6,3-6)' '(7,3-7)' '(8,3-8)' '(9,3-9)' '(10,3-10)' '(11,3-11)' '(12,3-12)' '(13,3-12)' '(14,3-12)' '(15,3-12)' '(16,3-12)' '(17,3-12)'} )
%set(gca, 'XTick',lower:upper, 'XTickLabel',{'(3,4-17)' '(4,4-17)' '(5,5-17)' '(6,6-17)' '(7,7-17)' '(8,8-17)' '(9,9-17)' '(10,10-17)' '(11,11-17)' '(12,12-17)' '(13,13-17)' '(14,14-17)' '(15,15-17)' '(16,16-17)' '(17,17)'} )
axis([3 17 0 0.1])
xticklabel_rotate([3:17],45,{'(3,4-17)' '(4,4-17)' '(5,5-17)' '(6,6-17)' '(7,7-17)' '(8,8-17)' '(9,9-17)' '(10,10-17)' '(11,11-17)' '(12,12-17)' '(13,13-17)' '(14,14-17)' '(15,15-17)' '(16,16-17)' '(17,17)'})
%save('EasterPECSLvsG2')