% Johan Sw?rd, Oct 2014
clearvars
%% Create a signal (sequence)
seqL = 1000; % The length of the sequence
seq = zeros(seqL,1); %Create a sequence
pA = [13 20]; % Which periodicities should be present in the sequence?
[seq, pA] = setPeriodicityBinary(seq, pA); % Add periodicities to the sequence
figure(1)
plot(seq(1:100),'*') % Can you see the periodicities?
Pn = 1/16;% Probability of changing 1 to 0
Pp = 1/4; % Probability of changing 0 to 1
[ seq ] = noiseAdderBinary(seq, Pp, Pn);
figure(2)
plot(seq(1:100),'r*')
%% Estimation
Y = seq;
nbrOfPeriods = 20; % Highest periodicity we are interested in
PnPrior = .5; % Makes sure we define a periodicity as a period in ones and not zeros.
% e.g. 001001 is a period of 3 and 110110 is two periods of 3.
chi2limit =  14.5848; %(MC=500000000, mmax=12)
silent = 1;
[perR, LrR, RatioOnes,T] = bruteForceIterSol(Y(:)', nbrOfPeriods, PnPrior,chi2limit,silent);

perR(perR==0)=[];

disp(['True periodicities are : '   num2str(pA)]) 
disp(['Estimated periodicities: '   num2str(perR(:)')]) 

